void merge(int vetor[], int comeco, int meio, int fim) {
    int com1 = comeco, com2 = meio+1, actualIndex = 0, tam = fim-comeco+1;
    int *vetAux;
    vetAux = (int*)malloc(tam * sizeof(int));

    while(com1 <= meio && com2 <= fim){
        if(vetor[com1] < vetor[com2]) {
            vetAux[actualIndex] = vetor[com1];
            com1++;
        } else {
            vetAux[actualIndex] = vetor[com2];
            com2++;
        }
        actualIndex++;
    }

    while(com1 <= meio){  //Caso ainda haja elementos na primeira metade
        vetAux[actualIndex] = vetor[com1];
        actualIndex++;
        com1++;
    }

    while(com2 <= fim) {   //Caso ainda haja elementos na segunda metade
        vetAux[actualIndex] = vetor[com2];
        actualIndex++;
        com2++;
    }

    for(actualIndex = comeco; actualIndex <= fim; actualIndex++){    //Move os elementos de volta para o vetor original
        vetor[actualIndex] = vetAux[actualIndex-comeco];
    }

    free(vetAux);
}

void mergeSort(int vetor[], int comeco, int fim){
    if (comeco < fim) {
        int meio = (fim+comeco)/2;

        mergeSort(vetor, comeco, meio);
        mergeSort(vetor, meio+1, fim);
        merge(vetor, comeco, meio, fim);
    }
}

int main()
{
    //vetor aqui
    mergeSort(vetor, 0, tam);
    //imprime aqui
    return 0;
}
